/***************************************************************************
                          givefreedaemon.cpp  -  description
                             -------------------
    begin                : Son Apr 15 14:14:12 CEST 2001
    copyright            : (C) 2001 by Emanuel Schmieg
    email                : kerneld@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "chatserversocket.h"

ChatServerSocket::ChatServerSocket(Q_UINT16 port, int backlog, QObject *parent, const char *name)
               : QServerSocket(port, backlog, parent, name)
{
}

ChatServerSocket::~ChatServerSocket()
{
}

void ChatServerSocket::newConnection (int socket){
 ChatSocket *newSocket = new ChatSocket (this);
 newSocket->setSocket(socket);
 connectionlist.append (newSocket);
 connect (newSocket, SIGNAL (connectionClosed()),
          SLOT (oneConnectionClosed()));
 connect (newSocket, SIGNAL (messageArrived(int, QString)),
          this, SIGNAL (newmessage (int, QString)));
 connect (newSocket, SIGNAL (editSocket()),
          this, SLOT(editSock()));
 emit connectionCounterChanged (connectionlist.count());
 emit socketsChanged(connectionlist);
}

void ChatServerSocket::oneConnectionClosed (){
 ChatSocket *sock = (ChatSocket *) sender();
 connectionlist.removeRef (sock);
 emit connectionCounterChanged (connectionlist.count());
 emit socketsChanged(connectionlist);
 QString msg("@");
 msg += sock->username();
 msg += '@';
 msg += sock->hostname();
 msg += ":~";
 emit newmessage (sock->ID(), msg);
 QTimer::singleShot (0, sock, SLOT (deleteMyself()));
}
/** Sends msg to all logged on Hosts */
void ChatServerSocket::sendAllHosts(QString msg){
 ChatSocket * current;
 for (current = connectionlist.first();connectionlist.current() != 0;
      current = connectionlist.next())
   {
    current->sendData (msg);
   }
}
/** sends msg to hostname */
void ChatServerSocket::sendToHost(QString msg, int id){
 ChatSocket * current;
 for (current = connectionlist.first();connectionlist.current() != 0;current = connectionlist.next())
   if (current->ID() == id)
     current->sendData (msg);
}
void ChatServerSocket::editSock(){
 emit socketsChanged(connectionlist);
}
ChatSocket* ChatServerSocket::getSocket(int id){
 ChatSocket* current;
 for (current = connectionlist.first();current != 0;current = connectionlist.next())
   {
    if (current->ID() == id)
      {
       return current;
      }
   }
 return 0;
}
/** closes the socket at pos */
void ChatServerSocket::closeSocket(int id){
 ChatSocket* current;
 for (current = connectionlist.first();current != 0;current = connectionlist.next())
   {
    if (current->ID() == id)
      {
       current->terminate();
       current->close();
       return;
      }
   }
}
