/***************************************************************************
                          givefreedaemon.h  -  description
                             -------------------
    begin                : Son Apr 15 14:14:12 CEST 2001
    copyright            : (C) 2001 by Emanuel Schmieg
    email                : kerneld@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHATSERVERSOCKET_H
#define CHATSERVERSOCKET_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <qserversocket.h>
#include <qlist.h>
#include <qtimer.h>
#include <qstring.h>

#include "chatsocket.h"

/** GiveFreeDaemon is the base class of the porject */
class ChatServerSocket : public QServerSocket
{
  Q_OBJECT 
  public:
    /** construtor */
    ChatServerSocket(Q_UINT16 port, int backlog=0, QObject* parent=0, const char *name=0);
    void newConnection (int socket);
    /** destructor */
    ~ChatServerSocket();
    ChatSocket* getSocket(int id);
    /** closes the socket with id */
    void closeSocket(int id);
  signals:
    void connectionCounterChanged (int number);
    void newmessage(int socketID, QString msg);
    /** this is emitted when a socket changed */
    void socketsChanged(QList <ChatSocket>);
  public slots:
    /** sends msg to hostname */
    void sendToHost(QString msg, int id);
    /** Sends msg to all logged on Hosts */
    void sendAllHosts(QString msg);
  private slots:
    void oneConnectionClosed ();
    void editSock();
  private:
    QList <ChatSocket> connectionlist;
};

#endif
