/***************************************************************************
                          givefreedaemonsocket.cpp  -  description
                             -------------------
    begin                : Sun Apr 15 2001
    copyright            : (C) 2001 by Emanuel Schmieg
    email                : kerneld@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "chatsocket.h"

int ChatSocket::counter = 0;

ChatSocket::ChatSocket(QObject *parent, const char *name)
                     : QSocket (parent, name){
  connect (this, SIGNAL (readyRead()),
           this, SLOT (receiveData()));
 this->host = "";
 this->user = "";
 counter++;
 id = counter;
}
ChatSocket::~ChatSocket(){
}
void ChatSocket::receiveData ()
{
  // This slot does the read server work!
  QString msg;
  while (canReadLine())
    {
     msg = this->readLine();//QTextStream s (this);
     msg.truncate (msg.length() - 1);
     if (!msg.contains('@'))
       return;
     if ((this->host == "") && (this->user == ""))
       {
        if (msg.at(0) == '@')
          {
           msg.remove(0, 1);
           this->host = msg.right(msg.length() - (msg.find('@') + 1));
           this->host = host.left(host.find(':'));
           this->user = msg.left(msg.find('@'));
           msg.prepend('@');
           emit editSocket();
          }
       }
     emit messageArrived (id, msg);
    }
}

void ChatSocket::sendData (QString msg){
 this->writeBlock(msg.append('\n').ascii(), msg.length() + 1);
}

void ChatSocket::deleteMyself ()
{
	// Let the socket object delete itself
	// This is something like a hack, since deleting an object while
	// running its own method is not very nice. But since after the
	// delete we are not using any member variables or virtual methods
	// of the object, this is safe.
	// Of course this slot may only be called for objects that were
	// created with "new".
	delete this;
}


QString ChatSocket::hostname(){
 return this->host;
}

QString ChatSocket::username(){
 return this->user;
}
int ChatSocket::ID(){
 return this->id;
}
/** No descriptions */
void ChatSocket::terminate(){
 emit connectionClosed();
}
