/***************************************************************************
                          givefreedaemonsocket.h  -  description
                             -------------------
    begin                : Sun Apr 15 2001
    copyright            : (C) 2001 by Emanuel Schmieg
    email                : kerneld@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHATSOCKET_H
#define CHATSOCKET_H

#include <qsocket.h>
#include <qtextstream.h>
#include <qhostaddress.h>
#include <qstring.h>
#include <iostream.h>

/**
  *@author Emanuel Schmieg
  */

class ChatSocket : public QSocket{
  Q_OBJECT
public:
	ChatSocket(QObject *parent = 0, const char *name = 0);
	~ChatSocket();
  QString hostname();
  QString username();
  int ID();
  /** No descriptions */
  void terminate();
signals:
  void messageArrived (int IDnumber, QString msg);
  /** No descriptions */
  void editSocket();
//  void closing();
public slots:
	/**
	  This little helping slot deletes the object itself. So it may
		only be called for objects created with new!
		It is used because the deletion is triggered by the signal
		connectionClosed. It could lead to a segfault if we deleted the
		object directly, since control comes back to that signal. So
		instead we start a zero-timer, that activates this slot. The
		zero-timer has its timeout not before we returned to the main
		event loop, and then it is safe to delete the object.
		See "ChatServerSocket::oneConnectionClosed()" for details of the
		implementation.
	*/
	void deleteMyself ();
  void sendData (QString msg);
private slots:
	/**
	  This private slot is called from the signal "readyRead", that
	  shows that new data is waiting for us.
	*/
	void receiveData ();
private:
  QString host;
  QString user;
  static int counter;
  int id;
};

#endif

